; Vysielac cez ATiny13
;
; Vyrobil : Vladimir Visnovsky "vVv"

 
; Nacitanie hlavnych parametrov procesora
.include "tn13def.inc"

.CSEG
.ORG 0
 rjmp	Initial
 rjmp	Initial
 rjmp	Initial
 rjmp	Initial
 rjmp	Initial
 rjmp	Initial
.ORG OC0Aaddr
 rjmp	Interupt
 rjmp	Initial
 rjmp	Initial
 rjmp	Initial
 
Initial:
 ; zakazanie prerusenia 
 cli
 rjmp	Init

; Nacitnanie kniznice posuvneho registra
.include "595.asm"
; Driver pre posuvny register 74xx595 cez port D
;
; * Konstanty
; w595_Port	- Port
; w595_Dat 	- Pin Data
; w595_Clk	- Pin Clock
; w595_Stb	- Pin Strobe
; R17 - B - Datovy register
; * Procedury
;   * w595_SendByte ( R17 - B )		Poslat Byte
;   * w595_Print					Vykreslit


Init:
; Inicializacia procesora

;  - Definicia premennych
;    - Akumulator
.DEF 	A		= R16
; 	 - Pomocny Akumulator
.DEF 	B		= R17
; 	 - Citace
.DEF 	C		= R18
.DEF	E		= R20
.DEF	E1		= R23
;    - Index Programu
.DEF	P		= R21
; 	 - Nula
.DEF	Z		= R22
;	 - Vlajky
.DEF 	D		= R19
; 0 - Stlacene tlacidlo
; 1 - Obsluzene tlacidlo
; 2 - Zapnuty
; 3 - Rozsvietenie
; 4 - Zhasnutie
; 5 - Rozsvetenie na 50%
; 6 - Ventilator
; 7 -

;  - Nastavenie zasobnika
 ldi	A		, 0x9F			; Nastavenie spodny byt zasobnika
 out 	SPL		, A
;  - Nastavenie portu B 
 ldi	A		, 0b00010111	; Nastavenie priechodu portou
 out 	DDRB	, A
 ldi	A		, 0b00101000	; Nastavenie vystupu portou
 out 	PORTB	, A
 
;  - Nastavenie casovaca
;    - Inicializacia a typ	
;		- TCCR0A
;		0 : WGM00		// CTC -> 0
; 		1 : WGM01		// CTC -> 1
;		- TCCR0B
;		0 : CS00		//  0		1		2		3		4
;		1 : CS01		//  Stop 	Clk		Clk/8	Clk/64	Clk/256
;		2 : CS03		//
;		3 : WGM02		// CTC -> 0
 ldi	A		, 0b00000010	; Nastavenie registra TCCR0A
 out 	TCCR0A	, A				; Typ citaca
 ldi	A		, 0b00000010	; Nastavenie registra TCCR0B
 out 	TCCR0B	, A				; Preddelicka
;	 - Prerusenie
;		- TIMSK0
;		1 : TOIE0		// Prerusenie od pretecenia
;		2 : OCIE0A		// Prerusenie od komparatora A	
;		3 : OCIE0B		// Prerusenie od komparatora B
 ldi	A		, 0b00000100	; Nastavenie registra TIMSK0
 out 	TIMSK0	, A				; Prerusenie od timera 0.A
;    - Registre casovacov
 ldi	A		, 0b00000000	; Nastavenie registra TCNT0
 out 	TCNT0	, A				
 ldi	A		, 50			; Nastavenie registra OCR0A
 out 	OCR0A	, A				; TOP citaca
 
 
; Prednastavenie pomocnych registov
 clr 	A
 clr	B
 clr 	C
 clr	D
 clr	E
 clr	E1
 clr	P
 clr 	Z
 clr	XL
 clr	XH
 ; Vynulovanie
 clr 	R0
 clr 	R1
 clr 	R2
 clr 	R3
 clr 	R4
 clr 	R5
 clr 	R6
 clr 	R7

; - Povolenie prerusenia
 sei 
; - Vycistenia registra 
 rcall	w595_SendByte;
 
Start: 			;	----- LOOP -----
 nop			;	/|\   		   |
 rjmp	Start	;	 | 			  \|/
; sleep			;	----- LOOP -----


; Hlavny podprogram
; - Obsluha prerusenia
Interupt:
 ; Citac
 inc	C					; Citac do 15
 cpi	C		, 32		; Porovnanie s cislom 32
 breq	iCtN				; Ak nieje menej ako 32
 rjmp	iCtEnd
 iCtN:
 clr	C					; Vynuluj C
 ori	B		, 0b00001111; Nastav B - PWM vystupy
 ;  Cyklus citaca f/32  	; -------------------------
 ; Tlacidlo
 sbis	PinB	, 3			; Test stlacenia klavesy
 rjmp	ikPush				; Tlacitko stlacene
 ;  Nestlacene
 ikNoPush:					; Nestlacene tlacitko
 bst	D		, 1			; Ak je procedura vykonana
 brtc	ikEnd				; Ak nieje skoc na koniec obsluhy tlacidla
 ;   Tlacitko pustene
 andi	D		, 0b11111100; Zlozenie vlajok stlacenia a vykonania 
 ;    Obsluha tlacidiel
 sbrs	E		, 6			; Preskoc ak je casovac stlacenia naplneny
 rjmp	ikSmal				; Ak je kratko stlacene
 ;     Stlacene dlho
 ikLarge:
 sbrc	D		, 2			; Preskoc ak je vlajka chodu dole
 rjmp	ikLStop				; Skoc 
       ; Start
 sbi	PortB	, 4			; Zapnutie pridrzneho rele
 ori	D		, 0b00100100; Zdvihnutie vlajky chodu a rozsvietenia 50%     
 andi	D		, 0b11100111; Zlozenie vlajky zhasenia      
 rjmp	ikEnd				; Skoc na koniec obsluhy tlacidla
       ; Stop
 ikLStop:      
 ;cbi	PortB	, 4			; vypnutie pridrzneho rele // Alternativa
 ori	B		, 0b00010000; zopnutie ventilatora
 ori	D		, 0b01010000; Zdvihnutie vlajky  zhasenia
 andi	D		, 0b11010011; Zlozenie vlajky chodu, a zasvietenia      
 clr	XL					; Vynulovanie casovaca ventilatora
 clr	XH
 rjmp	ikEnd				; Skoc na koniec obsluhy tlacidla
 ;     Stlacene kratko 
 ikSmal:
 sbrc	D		, 2			; Preskoc ak je vlajka chodu dole
 rjmp	ikStop				; Skoc 
       ; Start
 sbi	PortB	, 4			; Zapnutie pridrzneho rele
 ori	D		, 0b00001100; Zdvihnutie vlajky chodu a rozsvietenia      
 andi	D		, 0b11001111; Zlozenie vlajky zhasenia      
 rjmp	ikEnd				; Skoc na koniec obsluhy tlacidla
       ; Stop
 ikStop:      
 ;cbi	PortB	, 4			; vypnutie pridrzneho rele // Alternativa
 ori	D		, 0b00010000; Zdvihnutie vlajky  zhasenia
 andi	D		, 0b11010011; Zlozenie vlajky chodu, a zasvietenia      
 rjmp	ikEnd				; Skoc na koniec obsluhy tlacidla
 ;  Stlacene 
 ikPush:					; Stlacene tlacidlo
 ori	D		, 0b00000001; Zdvihnutie vlajky stlacenia       
 ;   Pocitadlo dlzky stlacenia
 inc	E1					; pricitane  k preddelicky timera E
 cpi	E1		, 1			; Porovnanie preddelicky 0,5s x 4 = 2sec
 brne	ikETimerEnd			; Ak este nieje urcena hodnota skoc dalej
 clr	E1					; vynulovanie preddelicky
 sbrs	E		, 6			; Preskoc ak je casovac stlacenia naplneny
 inc	E					; Pripocitanie
 ikETimerEnd:
 ;   Test vykonania 
 bst	D		, 1			; T <- Vlajka vykonania
 brts	ikEnd				; Ak je vlajka vykonania nastavena, preskoc
 ;   Prve stlacenie tlacidla
 clr	E					; Vynulovanie citaca stlacenia klavesy  
 clr	E1					; Vynulovanie citaca stlacenia klavesy  
 ori	D		, 0b00000010; Zdvihnutie vlajky vykonania       
 ikEnd:						; Koniec obsluhy stlacenia tlacitka
 ; Koniec obsluhy klavesnice
 ; Obsluha ventilatora
 sbrs	D		, 6			; ak je ventilator zopnuty
 rjmp	ivEnd				; ak je vypnuty, preskoc
 inc 	XL					; pricitanie XL
 cpi	XL		, 255		; ak nieje plny
 brne	ivEnd				; skoc na koniec
 clr	XL
 inc	XH					; pricitanie XH
 cpi	XH		, 100		;  DLZKA CAKANIA PRE START VENTILATORA
 brne	ivEnd				; skoc na koniec
 clr	XH
 andi	D		, 0b10111111; Vynulovanie vlajky ventilatora
 andi	B		, 0b11101111; Vypnutie ventilatora
 sbrs	D		, 2			; Ak je spustene svetlo, nevypinaj rele
 cbi	PortB	, 4			; vypnutie pridrzneho rele // Alternativa
 ivEnd: 
 ; Podprogramy ovladajuce Jas svetiel
 ; Start
 bst	D		, 3			; Poovnanie vlajky rozsvecovania
 brtc	ipStartEnd			; vlajka nieje zdvihnuta
 ; Prve svetlo
 bst	R0		, 5			; Porovnanie stvrteho bitu
 brts	ipStR0				; Ak je register naplneny skoc na dalsie sv.
 inc	R0					; inak pripocitaj
 rjmp	ipStartEnd			; Skoc na koniec rozsviecovania
 ipStR0:
 ; Druhe svetlo
 bst	R1		, 5			; Porovnanie stvrteho bitu
 brts	ipStR1				; Ak je register naplneny skoc na dalsie sv.
 inc	R1					; inak pripocitaj
 rjmp	ipStartEnd			; Skoc na koniec rozsviecovania
 ipStR1:
 ; Tretie svetlo
 bst	R2		, 5			; Porovnanie stvrteho bitu
 brts	ipStR2				; Ak je register naplneny skoc na dalsie sv.
 inc	R2					; inak pripocitaj
 rjmp	ipStartEnd			; Skoc na koniec rozsviecovania
 ipStR2:
 ; Stvrte svetlo
 bst	R3		, 5			; Porovnanie stvrteho bitu
 brts	ipStR3				; Ak je register naplneny skoc na dalsie sv.
 inc	R3					; inak pripocitaj
 rjmp	ipStartEnd			; Skoc na koniec rozsviecovania
 ipStR3:
 ; Dole vlajku START
 andi	D		, 0b11110111; dole vlajku START 
 ipStartEnd: 
 ; Stop
 bst	D		, 4			; Poovnanie vlajky rozsvecovania
 brtc	ipStopEnd			; vlajka nieje zdvihnuta
 ; Prve svetlo
 cp		R0		, Z			; Porovnanie stvrteho bitu
 breq	ipSpR0				; Ak je register prazny skoc na dalsie sv.
 dec	R0					; inak pripocitaj
 rjmp	ipStopEnd			; Skoc na koniec rozsviecovania
 ipSpR0:
 ; druhe svetlo
 cp		R1		, Z			; Porovnanie stvrteho bitu
 breq	ipSpR1				; Ak je register prazny skoc na dalsie sv.
 dec	R1					; inak pripocitaj
 rjmp	ipStopEnd			; Skoc na koniec rozsviecovania
 ipSpR1:
 ; Tretie svetlo
 cp		R2		, Z			; Porovnanie stvrteho bitu
 breq	ipSpR2				; Ak je register prazny skoc na dalsie sv.
 dec	R2					; inak pripocitaj
 rjmp	ipStopEnd			; Skoc na koniec rozsviecovania
 ipSpR2:
 ; Stvrte svetlo
 cp		R3		, Z			; Porovnanie stvrteho bitu
 breq	ipSpR3				; Ak je register prazny skoc na dalsie sv.
 dec	R3					; inak pripocitaj
 rjmp	ipStopEnd			; Skoc na koniec rozsviecovania
 ipSpR3:
 ; Ukoncenie programu stop
 sbrs	D		, 6			; Ak je spusteny ventilator, nevypinaj rele
 cbi	PortB	, 4			; vypnutie pridrzneho rele // Alternativa
 andi	D		, 0b11101111; dole vlajku STOP 
 ipStopEnd:
 ; Star 50%
 bst	D		, 5			; Poovnanie vlajky programu Start 50%
 brtc	ipStart5End			; vlajka nieje zdvihnuta
 ; Prve svetlo
 clr 	R0
 ; Druhe svetlo
 clr	R1
 ; Tretie svetlo
 bst	R2		, 5			; Porovnanie stvrteho bitu
 brts	ipS5R2				; Ak je register naplneny skoc na dalsie sv.
 inc	R2					; inak pripocitaj
 rjmp	ipStart5End			; Skoc na koniec rozsviecovania
 ipS5R2:
 ; Stvrte svetlo
 bst	R3		, 5			; Porovnanie stvrteho bitu
 brts	ipS5R3				; Ak je register naplneny skoc na dalsie sv.
 inc	R3					; inak pripocitaj
 rjmp	ipStart5End			; Skoc na koniec rozsviecovania
 ipS5R3:
 ; Dole vlajku START 50%
 andi	D		, 0b11011111; dole vlajku START  	
 ipStart5End:
 ; Koniec programu
 iCtEnd:					; Koniec obsluhy pocitadla
 ; Koniec obsluhy pocitadla 
 ; PWM Modulator
 clt
 cp		C		, R0		; Porovnanie registra jasu z citacom 
 brne 	iP0					; 
 bld	B		, 0			; Vynulovanie bitu v registru B
 iP0:
 cp		C		, R1		; Porovnanie registra jasu z citacom 
 brne 	iP1					; 
 bld	B		, 1			; Vynulovanie bitu v registru B
 iP1:
 cp		C		, R2		; Porovnanie registra jasu z citacom 
 brne 	iP2					; 
 bld	B		, 2			; Vynulovanie bitu v registru B
 iP2:
 cp		C		, R3		; Porovnanie registra jasu z citacom 
 brne 	iP3					; 
 bld	B		, 3			; Vynulovanie bitu v registru B
 iP3:
 ; Poslat do registra
 rjmp	w595_SendByte;
 ;rcall	w595_Print;
 reti						; Navrat z prerusenia
 
