'__________________________________________________________________________________
'
'                             ATX Tester
'__________________________________________________________________________________
'__________________________________________________________________________________
'
'                          Bascom 2.0.7.1
'
'                      * nastaven BOD na 4.1V
'                      * zobrazuje dve teploty a pocet cidel
'                      * COM -> 9600 Baud
'                      * meri napeti i zaporna
'                      * celkove zobrazeni formatovano
'                      * kalibrace napeti
'                      * !pri kmitani napeti pridat kapacitu k Aref!
'                      * vyber menu
'                      * vstup do Setup
'                      * spousteni zdroje tlacitkem OK
'                      * minima, maxima; podrzi udaje i na jinych rozsazich
'                      * zaznam se nuluje zapnutim
'                      * vypocet a zobrazeni tol., zobrazuje od -80%, mimo -12V
'                      * kalibrace do EEPROM
'                      * data na COM v celkovem prehledu
'                      * asymetricke vyhodnoceni tolerance
'                      * cervena LED pri prehrati
'                      * preskoceni -5V pokud neni pritomno
'                      * cas do COM vystupu, zobrazuje jen ruzne hodnoty po sobe
'                      * hacky a carky
'                      * napeti dle velikosti
'                      * watchdog
'                      *
'                      *
'
'__________________________________________________________________________________
'
'
'                      *
'                      *
'                      *
'                      *
'                      *
'
'__________________________________________________________________________________
'
'                     EEPROM:   1                  'Korekce vetve -5V
'    3                  'Korekce vetve 12V2
'    4                  'Korekce vetve 12V1
'    5                  'Korekce vetve 5V ST-BY
'    6                  'Korekce vetve 5V
'    7                  'Korekce vetve 3,3V
'    8                  'Korekce vetve -12V
'
'    10                 'Nastaveni teploty prehrati
'
'    11                 'Tolerance min -5V
'    13                 'Tolerance min 12V2
'    14                 'Tolerance min 12V1
'    15                 'Tolerance min 5V ST-BY
'    16                 'Tolerance min 5V
'    17                 'Tolerance min 3,3V
'    18                 'Tolerance min -12V
'
'    21                 'Tolerance max -5V
'    23                 'Tolerance max 12V2
'    24                 'Tolerance max 12V1
'    25                 'Tolerance max 5V ST-BY
'    26                 'Tolerance max 5V
'    27                 'Tolerance max 3,3V
'    28                 'Tolerance max -12V
'
'
'                      konf.: FF 3F C0 FF       XTAL  16MHz  Bootloader
'__________________________________________________________________________________
'
'  pripojeni   LCD            : PORT B.2, B.3, B.4, B.5, B.6, B.7
'              1Wire          : PORT C.0
'
'              Vstup -5V      : PORT A.0
'              Vstup PG       : PORT A.1
'              Vstup 12V2     : PORT A.2
'              Vstup 12V1     : PORT A.3
'              Vstup 5V ST-BY : PORT A.4
'              Vstup 5V       : PORT A.5
'              Vstup 3,3V     : PORT A.6
'              Vstup -12V     : PORT A.7
'
'              COM            : PORT D.1 (TX), D.0 (RX)
'              Klaves.        : PORT D.2, D.3, D.4
'              PWR ON         : PORT C.1
'              Piskle         : PORT C.2
'              LED            : PORT C.3, C.4
'
'
'__________________________________________________________________________________

$regfile = "m32def.dat"
$baud = 9600
$crystal = 16000000



Config 1wire = Portc.0                                      'Port s pripojenymi snimaci DS18B20
Config Porta.0 = Input                                      'Vstup -5V
Config Porta.1 = Input                                      'Vstup  PG
Config Porta.2 = Input                                      'Vstup  12V2
Config Porta.3 = Input                                      'Vstup  12V1
Config Porta.4 = Input                                      'Vstup  5V ST-BY
Config Porta.5 = Input                                      'Vstup  5V
Config Porta.6 = Input                                      'Vstup  3,3V
Config Porta.7 = Input                                      'Vstup -12V

Config Portc.1 = Output                                     'Vystup  PWR ON
Config Portc.2 = Output                                     'Vystup  PISKLE
Config Portc.3 = Output                                     'Vystup  LED RUDA
Config Portc.4 = Output                                     'Vystup  LED ZELENA

Config Portd.2 = Input                                      'Klavesnice OK
Config Portd.3 = Input                                      'Klavesnice R (+)
Config Portd.4 = Input                                      'Klavesnice L (-)

Config Portb = Output                                       'vystup LCD
Config Lcdbus = 4
Config Lcd = 20 * 4
Config Lcdpin = Pin , Db4 = Pb.4 , Db5 = Pb.5 , Db6 = Pb.6 , Db7 = Pb.7 , E = Pb.3 , Rs = Pb.2

Config Adc = Single , Prescaler = Auto , Reference = Aref

Config Clock = Soft
Config Date = Ymd , Separator = .                           ' ANSI-Format

Config Serialout = Buffered , Size = 40
Config Timer0 = Timer , Prescale = 8
On Ovf0 Tim0_isr
Config Watchdog = 2048

Start Watchdog

Enable Timer0
Enable Interrupts                                           'Zapina se kvuli Com


Deflcdchar 0 , 4 , 10 , 4 , 32 , 32 , 32 , 32 , 32          'znacka 
Deflcdchar 1 , 32 , 32 , 32 , 8 , 24 , 8 , 8 , 8            'mala 1
Deflcdchar 2 , 32 , 32 , 32 , 8 , 28 , 4 , 8 , 28           'mala 2
Deflcdchar 3 , 32 , 32 , 32 , 12 , 16 , 8 , 4 , 24          'male s
Deflcdchar 4 , 10 , 4 , 14 , 17 , 31 , 16 , 14 , 32         'e s hackem
Deflcdchar 5 , 10 , 4 , 22 , 25 , 16 , 16 , 16 , 32         'r s hackem
Deflcdchar 6 , 10 , 4 , 14 , 17 , 16 , 17 , 14 , 32         'c s hackem
Deflcdchar 7 , 1 , 2 , 12 , 4 , 4 , 4 , 14 , 32             'i dlouhe

Dim Adresy(16) As Byte                                      'mereni teploty
Dim Temp As Byte                                            'mereni teploty
Dim Temp1_str As String * 6                                 'mereni teploty
Dim Temp2_str As String * 6                                 'mereni teploty
Dim W As Byte                                               'mereni teploty
Dim T As Integer                                            'mereni teploty
Dim Cidlo_1(9) As Byte                                      'mereni teploty
Dim Cidlo_2(9) As Byte                                      'mereni teploty
Dim Stav As String * 5                                      'mereni teploty

Dim Channel(8) As Long                                      'mereni napeti
Dim Cykl As Byte                                            'mereni napeti
Dim Channel_str As String * 6                               'mereni napeti
Dim Korekce_pomocna As Byte                                 'mereni napeti
Dim Korekce_celkova(8) As Word                              'mereni napeti
Dim Minimum(8) As Long                                      'mereni napeti
Dim Maximum(8) As Long                                      'mereni napeti
Dim Minim As Long
Dim Maxim As Long
Dim Tolerance As Long                                       'vypocet tolerance
Dim Tolerance_pozadovana_min(8) As Byte                     'tolerance zadana
Dim Tolerance_pozadovana_max(8) As Byte                     'tolerance zadana
Dim Tolerance_pozadovana_pomocna As Byte                    'tolerance zadana
Dim Tolerance_str As String * 6

Dim Ok As Byte                                              'Koder stisknuti
Dim Pomocna_koder As Byte                                   'Minuly stav koderu
Dim Koder As Byte                                           'Koder otoceni
Dim Koder1 As Byte                                          'Koder otoceni
Dim Pomocna_ok As Byte                                      'Minuly stav ok

Dim Citani_casu As Dword                                    'Mereni casu PG
Dim Citani_casu_str As String * 8                           'Mereni casu PG
Dim Citani_time_overflow As Bit                             'Mereni casu PG, preteceni casu mereni -> 5000ms
Dim Citani_start_reset As Bit                               'Mereni casu PG, vynechani prvniho mereni
Dim Citani_pocet_mereni As Byte                             'Mereni casu PG, pocet cyklu mereni

Dim Prehrati As Byte

Dim Printport(10) As String * 6
Dim Export As String * 62
Dim Export_crc As Byte
Dim Export_crc_old As Byte
Dim Ini_temp As Byte                                        'Print az po tretim obehu

Reset Watchdog

Gosub Inicializace

Gosub Nacteni_korekci


Cls
Cursor Off
Locate 2 , 1
Lcd "     ATX Tester     "
Locate 4 , 1
Lcd "       SW.:47       "
Print
Print
Print "  TIME     PG    3V3   5V 5VSB 12V1 12V2  -5V   -12V  T1   T2"
Print "--------------------------------------------------------------"
Waitms 500
Cls





Do

Reset Watchdog

Gosub Klavesnice

Gosub Ovladani_zdroje

Gosub Mereni_teploty

Gosub Mereni_napeti

Gosub Minima_maxima

Gosub Rezim_zobrazeni

Loop

End                                                         'end program









Ovladani_zdroje:

If Ok = 1 Then
   Portc.4 = 0                                              'Vystup zapnut LED ZELENA
   Portc.1 = 1                                              'Vystup zapnut PWR ON
   Tcnt0 = 0
'   Print ">" ; Tcnt0
'   Start Timer0                                             'zapne timer na mereni casu PG
   If Pomocna_ok = 0 Then                                   'vymaze minimum a maximum pri zapnuti ci vyputi zdroje
   'If Pomocna_ok < Ok Then                                     'vymaze minimum a maximum pri zapnuti ci vyputi zdroje
      Gosub Vymazani_minim
   Pomocna_ok = 1
   End If

  Else
   Portc.4 = 1                                              'Vystup vypnut LED ZELENA
   Portc.1 = 0                                              'Vystup vypnut PWR ON
   Pomocna_ok = 0
End If

Return





Rezim_zobrazeni:

If Koder = 0 Then                                           'celkovy prehled
   Gosub Zobrazeni_lcd
End If

If Koder = 1 Then                                           'Vetev 3,3V
   Gosub Zobrazeni_3v3
End If

If Koder = 2 Then                                           'Vetev 5,0V
   Gosub Zobrazeni_5v0
End If

If Koder = 3 Then                                           'Vetev 5,0V stand by
   Gosub Zobrazeni_5v0stby
End If

If Koder = 4 Then                                           'Vetev 12V 1
   Gosub Zobrazeni_12v1
End If

If Koder = 5 Then                                           'Vetev 12V 2
   Gosub Zobrazeni_12v2
End If

If Koder = 6 Then                                           'Vetev minus 12V
   Gosub Zobrazeni_m12v
End If

If Koder = 7 Then                                           'Vetev minus 5V
   If Channel(1) < 50 Then                                  'Preskoci zobrazeni pri chybejicim napeti -5V
      Incr Koder
     Else
      Gosub Zobrazeni_m5v
   End If
End If

If Koder = 8 Then                                           'Mereni casu PG
   Ok = 0                                                   'vypne zdroj pokud bezi
   Gosub Mereni_casu_pg
End If

Return




Mereni_casu_pg:                                             'Meri start -> PG

Locate 1 , 3
Lcd "M" ; Chr(4) ; Chr(5) ; "en" ; Chr(7) ; " " ; Chr(6) ; "asu PG"

Portc.4 = 0                                                 'Vystup zapnut LED ZELENA
Portc.1 = 1                                                 'Vystup zapnut PWR ON

Start Timer0

Do
Channel(2) = Getadc(1)
If Citani_time_overflow = 1 Then
   Channel(2) = 101
End If
Loop Until Channel(2) > 100

Portc.4 = 1                                                 'Vystup zapnut LED ZELENA
Portc.1 = 0                                                 'Vystup zapnut PWR ON

Stop Timer0
Citani_time_overflow = 0

Citani_casu = Citani_casu * 1000
Citani_casu = Citani_casu / 7812
Citani_casu_str = Str(citani_casu)

If Citani_start_reset = 1 Then
   Locate 3 , 8
   Lcd Citani_casu_str ; " ms      "
  Else
   Citani_start_reset = 1
End If

Citani_casu = 0

Incr Citani_pocet_mereni
If Citani_pocet_mereni > 9 Then
   Koder = 0
   Citani_pocet_mereni = 0
End If

Return





Zobrazeni_3v3:                                              'Zobrazeni vetve 3V3

Locate 1 , 6
Lcd "V" ; Chr(4) ; "tev 3,3V"
Channel(7) = Channel(7) * Korekce_celkova(7)                'Korekce vetve 3,3V
Channel(7) = Channel(7) / 2000
Channel_str = Str(channel(7))
Channel_str = Format(channel_str , "0.00")
Locate 2 , 1
Lcd "Cont: " ; Channel_str ; "V"

Minim = Minimum(7) * Korekce_celkova(7)
Minim = Minim / 2000
Channel_str = Str(minim)
Channel_str = Format(channel_str , "0.00")
Locate 3 , 1
Lcd " Min: " ; Channel_str ; "V"

Maxim = Maximum(7) * Korekce_celkova(7)
Maxim = Maxim / 2000
Channel_str = Str(maxim)
Channel_str = Format(channel_str , "0.00")
Locate 4 , 1
Lcd " Max: " ; Channel_str ; "V"

Channel(7) = Getadc(6)                                      'znovunacteni promenne, menila se

Tolerance = Channel(7) * Korekce_celkova(7)                 'novy vypocet pro toleranci
Tolerance = Tolerance / 20
Tolerance = Tolerance / 33
Tolerance = Tolerance - 1000

If Tolerance < -800 Then                                    'omezuje zobrazeny rozsah tolerance
   Locate 2 , 14
   Lcd "      "
   Return
  Else
   If Tolerance < 0 Then                                    'zobrazuje v procentech odchylku
      Tolerance_str = Str(tolerance)
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_min(7)
    Else
      Tolerance_str = Str(tolerance)                        'zobrazuje v procentech odchylku, vlozena mezera aby se cislo neposouvalo pri zaporne hodnote
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd " " ; Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_max(7)
   End If

Tolerance = Abs(tolerance)

   If Tolerance < Tolerance_pozadovana_pomocna Or Tolerance = Tolerance_pozadovana_pomocna Then       'vyhodnocen tolerance
'   If Tolerance < Tolerance_pozadovana(7) Or Tolerance = Tolerance_pozadovana(7) Then       'vyhodnocen tolerance
      Locate 1 , 18
      Lcd "OK"
     Else
      Locate 1 , 18
      Lcd "--"
   End If
End If

Return


Zobrazeni_5v0:                                              'Zobrazeni vetve 5V0

Locate 1 , 6
Lcd "V" ; Chr(4) ; "tev 5,0V"
Channel(6) = Channel(6) * Korekce_celkova(6)                'Korekce vetve 5V
Channel(6) = Channel(6) / 1000
Channel_str = Str(channel(6))
Channel_str = Format(channel_str , "0.00")
Locate 2 , 1
Lcd "Cont: " ; Channel_str ; "V"

Minim = Minimum(6) * Korekce_celkova(6)
Minim = Minim / 1000
Channel_str = Str(minim)
Channel_str = Format(channel_str , "0.00")
Locate 3 , 1
Lcd " Min: " ; Channel_str ; "V"

Maxim = Maximum(6) * Korekce_celkova(6)
Maxim = Maxim / 1000
Channel_str = Str(maxim)
Channel_str = Format(channel_str , "0.00")
Locate 4 , 1
Lcd " Max: " ; Channel_str ; "V"

Channel(6) = Getadc(5)                                      'znovunacteni promenne, menila se

Tolerance = Channel(6) * Korekce_celkova(6)                 'novy vypocet pro toleranci
Tolerance = Tolerance / 100
Tolerance = Tolerance / 5
Tolerance = Tolerance - 1000

If Tolerance < -800 Then                                    'omezuje zobrazeny rozsah tolerance
   Locate 2 , 14
   Lcd "      "
   Return
  Else
   If Tolerance < 0 Then                                    'zobrazuje v procentech odchylku
      Tolerance_str = Str(tolerance)
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_min(6)
    Else
      Tolerance_str = Str(tolerance)                        'zobrazuje v procentech odchylku, vlozena mezera aby se cislo neposouvalo pri zaporne hodnote
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd " " ; Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_max(6)
   End If

Tolerance = Abs(tolerance)

   If Tolerance < Tolerance_pozadovana_pomocna Or Tolerance = Tolerance_pozadovana_pomocna Then       'vyhodnocen tolerance
'   If Tolerance < Tolerance_pozadovana(6) Or Tolerance = Tolerance_pozadovana(6) Then       'vyhodnocen tolerance
      Locate 1 , 18
      Lcd "OK"
     Else
      Locate 1 , 18
      Lcd "--"
   End If
End If

Return


Zobrazeni_5v0stby:                                          'Zobrazeni vetve 5V0 ST-BY

Locate 1 , 4
Lcd "V" ; Chr(4) ; "tev 5,0V SB"
Channel(5) = Channel(5) * Korekce_celkova(5)                'Korekce vetve 5V ST-BY
Channel(5) = Channel(5) / 1000
Channel_str = Str(channel(5))
Channel_str = Format(channel_str , "0.00")
Locate 2 , 1
Lcd "Cont: " ; Channel_str ; "V"

Minim = Minimum(5) * Korekce_celkova(5)
Minim = Minim / 1000
Channel_str = Str(minim)
Channel_str = Format(channel_str , "0.00")
Locate 3 , 1
Lcd " Min: " ; Channel_str ; "V"

Maxim = Maximum(5) * Korekce_celkova(5)
Maxim = Maxim / 1000
Channel_str = Str(maxim)
Channel_str = Format(channel_str , "0.00")
Locate 4 , 1
Lcd " Max: " ; Channel_str ; "V"

Channel(5) = Getadc(4)                                      'znovunacteni promenne, menila se

Tolerance = Channel(5) * Korekce_celkova(5)                 'novy vypocet pro toleranci
Tolerance = Tolerance / 100
Tolerance = Tolerance / 5
Tolerance = Tolerance - 1000

If Tolerance < -800 Then                                    'omezuje zobrazeny rozsah tolerance
   Locate 2 , 14
   Lcd "      "
   Return
  Else
   If Tolerance < 0 Then                                    'zobrazuje v procentech odchylku
      Tolerance_str = Str(tolerance)
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_min(5)
    Else
      Tolerance_str = Str(tolerance)                        'zobrazuje v procentech odchylku, vlozena mezera aby se cislo neposouvalo pri zaporne hodnote
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd " " ; Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_max(5)
   End If

Tolerance = Abs(tolerance)

   If Tolerance < Tolerance_pozadovana_pomocna Or Tolerance = Tolerance_pozadovana_pomocna Then       'vyhodnocen tolerance
'   If Tolerance < Tolerance_pozadovana(5) Or Tolerance = Tolerance_pozadovana(5) Then       'vyhodnocen tolerance
      Locate 1 , 18
      Lcd "OK"
     Else
      Locate 1 , 18
      Lcd "--"
   End If
End If

Return


Zobrazeni_12v1:                                             'Zobrazeni vetve 12V 1

Locate 1 , 5
Lcd "V" ; Chr(4) ; "tev 12V-1"
Channel(4) = Channel(4) * Korekce_celkova(4)                'Korekce vetve 12V1
Channel(4) = Channel(4) / 5000
Channel_str = Str(channel(4))
Channel_str = Format(channel_str , "00.0")
Locate 2 , 1
Lcd "Cont: " ; Channel_str ; "V"

Minim = Minimum(4) * Korekce_celkova(4)
Minim = Minim / 5000
Channel_str = Str(minim)
Channel_str = Format(channel_str , "00.0")
Locate 3 , 1
Lcd " Min: " ; Channel_str ; "V"

Maxim = Maximum(4) * Korekce_celkova(4)
Maxim = Maxim / 5000
Channel_str = Str(maxim)
Channel_str = Format(channel_str , "00.0")
Locate 4 , 1
Lcd " Max: " ; Channel_str ; "V"

Channel(4) = Getadc(3)                                      'znovunacteni promenne, menila se

Tolerance = Channel(4) * Korekce_celkova(4)                 'novy vypocet pro toleranci
Tolerance = Tolerance / 50
Tolerance = Tolerance / 12
Tolerance = Tolerance - 1000

If Tolerance < -800 Then                                    'omezuje zobrazeny rozsah tolerance
   Locate 2 , 14
   Lcd "      "
   Return
  Else
   If Tolerance < 0 Then                                    'zobrazuje v procentech odchylku
      Tolerance_str = Str(tolerance)
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_min(4)
    Else
      Tolerance_str = Str(tolerance)                        'zobrazuje v procentech odchylku, vlozena mezera aby se cislo neposouvalo pri zaporne hodnote
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd " " ; Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_max(4)
   End If

Tolerance = Abs(tolerance)

   If Tolerance < Tolerance_pozadovana_pomocna Or Tolerance = Tolerance_pozadovana_pomocna Then       'vyhodnocen tolerance
'   If Tolerance < Tolerance_pozadovana(4) Or Tolerance = Tolerance_pozadovana(4) Then       'vyhodnocen tolerance
      Locate 1 , 18
      Lcd "OK"
     Else
      Locate 1 , 18
      Lcd "--"
   End If
End If

Return


Zobrazeni_12v2:                                             'Zobrazeni vetve 12V 2

Locate 1 , 5
Lcd "V" ; Chr(4) ; "tev 12V-2"
Channel(3) = Channel(3) * Korekce_celkova(3)                'Korekce vetve 12V2
Channel(3) = Channel(3) / 5000
Channel_str = Str(channel(3))
Channel_str = Format(channel_str , "00.0")
Locate 2 , 1
Lcd "Cont: " ; Channel_str ; "V"

Minim = Minimum(3) * Korekce_celkova(3)
Minim = Minim / 5000
Channel_str = Str(minim)
Channel_str = Format(channel_str , "00.0")
Locate 3 , 1
Lcd " Min: " ; Channel_str ; "V"

Maxim = Maximum(3) * Korekce_celkova(3)
Maxim = Maxim / 5000
Channel_str = Str(maxim)
Channel_str = Format(channel_str , "00.0")
Locate 4 , 1
Lcd " Max: " ; Channel_str ; "V"

Channel(3) = Getadc(2)                                      'znovunacteni promenne, menila se

Tolerance = Channel(3) * Korekce_celkova(3)                 'novy vypocet pro toleranci
Tolerance = Tolerance / 50
Tolerance = Tolerance / 12
Tolerance = Tolerance - 1000

If Tolerance < -800 Then                                    'omezuje zobrazeny rozsah tolerance
   Locate 2 , 14
   Lcd "      "
   Return
  Else
   If Tolerance < 0 Then                                    'zobrazuje v procentech odchylku
      Tolerance_str = Str(tolerance)
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_min(3)
    Else
      Tolerance_str = Str(tolerance)                        'zobrazuje v procentech odchylku, vlozena mezera aby se cislo neposouvalo pri zaporne hodnote
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd " " ; Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_max(3)
   End If

Tolerance = Abs(tolerance)

   If Tolerance < Tolerance_pozadovana_pomocna Or Tolerance = Tolerance_pozadovana_pomocna Then       'vyhodnocen tolerance
'   If Tolerance < Tolerance_pozadovana(3) Or Tolerance = Tolerance_pozadovana(3) Then       'vyhodnocen tolerance
      Locate 1 , 18
      Lcd "OK"
     Else
      Locate 1 , 18
      Lcd "--"
   End If
End If

Return


Zobrazeni_m12v:                                             'Zobrazeni vetve minus 12V

Locate 1 , 6
Lcd "V" ; Chr(4) ; "tev -12V"
Channel(8) = Channel(8) * Korekce_celkova(8)                'Korekce vetve -12V
Channel(8) = Channel(8) / 10000
If Channel(8) > 5 Then                                      'pri U > 0,5V pricte 8V, aby bez napeti byla nula
   Channel(8) = Channel(8) + 80
End If
Channel_str = Str(channel(8))
Channel_str = Format(channel_str , "00.0")
Locate 2 , 1
Lcd "Cont: " ; "-" ; Channel_str ; "V"

Minim = Minimum(8) * Korekce_celkova(8)
Minim = Minim / 10000
If Minim > 5 Then                                           'pri U > 0,5V pricte 8V, aby bez napeti byla nula
   Minim = Minim + 80
End If
Channel_str = Str(minim)
Channel_str = Format(channel_str , "00.0")
Locate 3 , 1
Lcd " Min: " ; "-" ; Channel_str ; "V"

Maxim = Maximum(8) * Korekce_celkova(8)
Maxim = Maxim / 10000
If Maxim > 5 Then                                           'pri U > 0,5V pricte 8V, aby bez napeti byla nula
   Maxim = Maxim + 80
End If
Channel_str = Str(maxim)
Channel_str = Format(channel_str , "00.0")
Locate 4 , 1
Lcd " Max: " ; "-" ; Channel_str ; "V"

Channel(8) = Getadc(7)                                      'znovunacteni promenne, menila se

Tolerance = Channel(8) * Korekce_celkova(8)                 'novy vypocet pro toleranci
Tolerance = Tolerance / 100
Tolerance = Tolerance + 8000                                'pricteni konstanty prevodniku
Tolerance = Tolerance / 12
Tolerance = Tolerance - 1000

If Tolerance > 150 Or Tolerance < -150 Then                 'omezuje zobrazeny rozsah tolerance, zde mensi linearita
   Locate 2 , 14
   Lcd "      "
   Return
  Else
   If Tolerance < 0 Then                                    'zobrazuje v procentech odchylku
      Tolerance_str = Str(tolerance)
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_min(8)
    Else
      Tolerance_str = Str(tolerance)                        'zobrazuje v procentech odchylku, vlozena mezera aby se cislo neposouvalo pri zaporne hodnote
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd " " ; Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_max(8)
   End If

Tolerance = Abs(tolerance)

   If Tolerance < Tolerance_pozadovana_pomocna Or Tolerance = Tolerance_pozadovana_pomocna Then       'vyhodnocen tolerance
'   If Tolerance < Tolerance_pozadovana(8) Or Tolerance = Tolerance_pozadovana(8) Then       'vyhodnocen tolerance
      Locate 1 , 18
      Lcd "OK"
     Else
      Locate 1 , 18
      Lcd "--"
   End If
End If

Return


Zobrazeni_m5v:                                              'Zobrazeni vetve minus 5V

Locate 1 , 6
Lcd "V" ; Chr(4) ; "tev -5V"
Channel(1) = Channel(1) * Korekce_celkova(1)                'Korekce vetve -5V
Channel(1) = Channel(1) / 1000
If Channel(1) > 50 Then                                     'pri U > 0,5V pricte 0,8V, aby bez napeti byla nula
   Channel(1) = Channel(1) + 80
End If
Channel_str = Str(channel(1))
Channel_str = Format(channel_str , "0.00")
Locate 2 , 1
Lcd "Cont: " ; "-" ; Channel_str ; "V"

Minim = Minimum(1) * Korekce_celkova(1)
Minim = Minim / 1000
If Minim > 5 Then                                           'pri U > 0,5V pricte 8V, aby bez napeti byla nula
   Minim = Minim + 80
End If
Channel_str = Str(minim)
Channel_str = Format(channel_str , "0.00")
Locate 3 , 1
Lcd " Min: " ; "-" ; Channel_str ; "V"

Maxim = Maximum(1) * Korekce_celkova(1)
Maxim = Maxim / 1000
If Maxim > 5 Then                                           'pri U > 0,5V pricte 8V, aby bez napeti byla nula
   Maxim = Maxim + 80
End If
Channel_str = Str(maxim)
Channel_str = Format(channel_str , "0.00")
Locate 4 , 1
Lcd " Max: " ; "-" ; Channel_str ; "V"

Channel(1) = Getadc(0)                                      'znovunacteni promenne, menila se

Tolerance = Channel(1) * Korekce_celkova(1)                 'novy vypocet pro toleranci
Tolerance = Tolerance / 100
Tolerance = Tolerance + 800                                 'pricteni konstanty prevodniku
Tolerance = Tolerance / 5
Tolerance = Tolerance - 1000

'Print Channel(1) ; " " ; Tolerance ; " " ; Tolerance_pozadovana(8)

If Tolerance < -800 Then                                    'omezuje zobrazeny rozsah tolerance, zde mensi linearita
   Locate 2 , 14
   Lcd "      "
   Return
  Else
   If Tolerance < 0 Then                                    'zobrazuje v procentech odchylku
      Tolerance_str = Str(tolerance)
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_min(1)
    Else
      Tolerance_str = Str(tolerance)                        'zobrazuje v procentech odchylku, vlozena mezera aby se cislo neposouvalo pri zaporne hodnote
      Tolerance_str = Format(tolerance_str , "00.0")
      Locate 2 , 14
      Lcd " " ; Tolerance_str ; "% "
      Tolerance_pozadovana_pomocna = Tolerance_pozadovana_max(1)
   End If

Tolerance = Abs(tolerance)

   If Tolerance < Tolerance_pozadovana_pomocna Or Tolerance = Tolerance_pozadovana_pomocna Then       'vyhodnocen tolerance
'   If Tolerance < Tolerance_pozadovana(1) Or Tolerance = Tolerance_pozadovana(1) Then       'vyhodnocen tolerance
      Locate 1 , 18
      Lcd "OK"
     Else
      Locate 1 , 18
      Lcd "--"
   End If
End If

Return





Minima_maxima:

If Ok = 1 Then

If Channel(1) < Minimum(1) Then
   Minimum(1) = Channel(1)
End If
If Channel(1) > Maximum(1) Then
   Maximum(1) = Channel(1)
End If

If Channel(3) < Minimum(3) Then
   Minimum(3) = Channel(3)
End If
If Channel(3) > Maximum(3) Then
   Maximum(3) = Channel(3)
End If

If Channel(4) < Minimum(4) Then
   Minimum(4) = Channel(4)
End If
If Channel(4) > Maximum(4) Then
   Maximum(4) = Channel(4)
End If

If Channel(5) < Minimum(5) Then
   Minimum(5) = Channel(5)
End If
If Channel(5) > Maximum(5) Then
   Maximum(5) = Channel(5)
End If

If Channel(6) < Minimum(6) Then
   Minimum(6) = Channel(6)
End If
If Channel(6) > Maximum(6) Then
   Maximum(6) = Channel(6)
End If

If Channel(7) < Minimum(7) Then
   Minimum(7) = Channel(7)
End If
If Channel(7) > Maximum(7) Then
   Maximum(7) = Channel(7)
End If

If Channel(8) < Minimum(8) Then
   Minimum(8) = Channel(8)
End If
If Channel(8) > Maximum(8) Then
   Maximum(8) = Channel(8)
End If

End If

Return






Zobrazeni_menu:
Cls
Ok = 0

Locate 1 , 4
Lcd "SETUP KOREKCE  "
Wait 1

Readeeprom Koder1 , 1
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina  -5V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 1
Ok = 0
Waitms 300

Readeeprom Koder1 , 3
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 12V2: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 3
Ok = 0
Waitms 300

Readeeprom Koder1 , 4
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 12V1: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 4
Ok = 0
Waitms 300

Readeeprom Koder1 , 5
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 5VSB: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 5
Ok = 0
Waitms 300

Readeeprom Koder1 , 6
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina   5V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 6
Ok = 0
Waitms 300

Readeeprom Koder1 , 7
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 3,3V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 7
Ok = 0
Waitms 300

Readeeprom Koder1 , 8
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina -12V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 8
Ok = 0
Waitms 300

Locate 1 , 1
Lcd "SETUP TOLERANCE MIN"
Locate 2 , 8
Lcd "x 0,1%"


Readeeprom Koder1 , 11
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina  -5V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 11
Ok = 0
Waitms 300

Readeeprom Koder1 , 13
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 12V2: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 13
Ok = 0
Waitms 300

Readeeprom Koder1 , 14
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 12V1: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 14
Ok = 0
Waitms 300

Readeeprom Koder1 , 15
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 5VSB: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 15
Ok = 0
Waitms 300

Readeeprom Koder1 , 16
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina   5V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 16
Ok = 0
Waitms 300

Readeeprom Koder1 , 17
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 3,3V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 17
Ok = 0
Waitms 300

Readeeprom Koder1 , 18
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina -12V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 18
Ok = 0
Waitms 300

Locate 1 , 1
Lcd "SETUP TOLERANCE MAX"
Locate 2 , 8
Lcd "x 0,1%"


Readeeprom Koder1 , 21
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina  -5V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 21
Ok = 0
Waitms 300

Readeeprom Koder1 , 23
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 12V2: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 23
Ok = 0
Waitms 300

Readeeprom Koder1 , 24
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 12V1: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 24
Ok = 0
Waitms 300

Readeeprom Koder1 , 25
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 5VSB: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 25
Ok = 0
Waitms 300

Readeeprom Koder1 , 26
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina   5V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 26
Ok = 0
Waitms 300

Readeeprom Koder1 , 27
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina 3,3V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 27
Ok = 0
Waitms 300

Readeeprom Koder1 , 28
Do
   Gosub Klavesnice_mala
   Locate 3 , 2
   Lcd "Hladina -12V: " ; Koder1 ; "  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 28
Ok = 0
Waitms 300

Cls
Locate 1 , 4
Lcd "SETUP PREHRATI"
'Locate 2 , 8
'Lcd "x 0,1%"


Readeeprom Koder1 , 10
Do
   Gosub Klavesnice_mala
   Locate 3 , 4
   Lcd "Teplota: " ; Koder1 ; Chr(0) ; "C  "
   Reset Watchdog
Loop Until Ok = 1
Writeeeprom Koder1 , 10
Ok = 0

Gosub Inicializace
Cls

Return






Klavesnice_mala:

If Pind.2 = 0 Then                                          'Klavesnice OK
   Incr Ok
   Gosub Pip
End If

If Pind.3 = 0 Then                                          'Klavesnice R (+)
   Incr Koder1
   Gosub Pip
End If

If Pind.4 = 0 Then                                          'Klavesnice L (-)
   Decr Koder1
   Gosub Pip
End If

If Ok > 1 And Ok < 255 Then                                 'Osetreni OK
   Ok = 0
End If
If Ok = 255 Then
   Ok = 1
End If

Return






Klavesnice:

If Pind.2 = 0 Then                                          'Klavesnice OK
   Incr Ok
   Gosub Pip
End If

If Pind.3 = 0 Then                                          'Klavesnice R (+)
   Incr Koder
   Gosub Pip
End If

If Pind.4 = 0 Then                                          'Klavesnice L (-)
   Decr Koder
   Gosub Pip
End If

If Pind.3 = 0 And Pind.4 = 0 Then                           'Klavesnice R a L
   Gosub Zobrazeni_menu
End If

If Koder > 8 And Koder < 255 Then
   Koder = 0
End If
If Koder = 255 Then
   Koder = 8
End If

If Ok > 1 And Ok < 255 Then                                 'Osetreni OK
   Ok = 0
End If
If Ok = 255 Then
   Ok = 1
End If


If Pomocna_koder < Koder Or Pomocna_koder > Koder Then
   Cls
   Pomocna_koder = Koder
End If

Waitms 100

Return







Zobrazeni_lcd:                                              'Celkovy prehled

Locate 1 , 14
Lcd " " ; Temp1_str ; Chr(0) ; "C "                         ' Teplota 1
Printport(1) = Temp1_str

Locate 2 , 14
Lcd " " ; Temp2_str ; Chr(0) ; "C "                         ' Teplota 2
Printport(2) = Temp2_str

Channel(1) = Channel(1) * Korekce_celkova(1)                'Korekce vetve -5V
Channel(1) = Channel(1) / 1000
If Channel(1) > 50 Then                                     'pri U > 0,5V pricte 0,8V, aby bez napeti byla nula
   Channel(1) = Channel(1) + 80
End If
Channel_str = Str(channel(1))
Channel_str = Format(channel_str , "0.00")
Printport(3) = Channel_str
Locate 4 , 1
If Channel(1) > 1 Then                                      'preskakuje zobrazeni pri 0V
   Locate 4 , 1
   Lcd "-" ; Channel_str ; "V"
  Else
   Lcd "      "
End If

If Channel(2) > 100 Then                                    'Korekce vetve PG
   Locate 1 , 2
   Lcd "PG-OK "
   Printport(4) = "PG-OK "
  Else
   Locate 1 , 2
   Lcd "PG-NOT"
   Printport(4) = "PG-NOT"
End If

Channel(3) = Channel(3) * Korekce_celkova(3)                'Korekce vetve 12V2
Channel(3) = Channel(3) / 5000
Channel_str = Str(channel(3))
Channel_str = Format(channel_str , "00.0")
Printport(5) = Channel_str
Locate 3 , 9
Lcd Channel_str ; "V" ; Chr(2)

Channel(4) = Channel(4) * Korekce_celkova(4)                'Korekce vetve 12V1
Channel(4) = Channel(4) / 5000
Channel_str = Str(channel(4))
Channel_str = Format(channel_str , "00.0")
Printport(6) = Channel_str
Locate 3 , 2
Lcd Channel_str ; "V" ; Chr(1)

Channel(5) = Channel(5) * Korekce_celkova(5)                'Korekce vetve 5V ST-BY
Channel(5) = Channel(5) / 1000
Channel_str = Str(channel(5))
Channel_str = Format(channel_str , "0.00")
Printport(7) = Channel_str
Locate 2 , 2
Lcd Channel_str ; "V" ; Chr(3)

Channel(6) = Channel(6) * Korekce_celkova(6)                'Korekce vetve 5V
Channel(6) = Channel(6) / 1000
Channel_str = Str(channel(6))
Channel_str = Format(channel_str , "0.00")
Printport(8) = Channel_str
Locate 2 , 9
Lcd Channel_str ; "V"

Channel(7) = Channel(7) * Korekce_celkova(7)                'Korekce vetve 3,3V
Channel(7) = Channel(7) / 2000
Channel_str = Str(channel(7))
Channel_str = Format(channel_str , "0.00")
Printport(9) = Channel_str
Locate 1 , 9
Lcd Channel_str ; "V"

Channel(8) = Channel(8) * Korekce_celkova(8)                'Korekce vetve -12V
Channel(8) = Channel(8) / 10000
If Channel(8) > 5 Then                                      'pri U > 0,5V pricte 8V, aby bez napeti byla nula
   Channel(8) = Channel(8) + 80
End If
Channel_str = Str(channel(8))
Channel_str = Format(channel_str , "00.0")
Printport(10) = Channel_str
Locate 4 , 8
Lcd "-" ; Channel_str ; "V"

If Ini_temp < 2 Then                                        'Print az po tretim preskoku
  Incr Ini_temp
  Return
End If

Gosub Print_port

Return





Mereni_teploty:

Adresy(1) = 1wsearchfirst()
Adresy(9) = 1wsearchnext()
W = 1wirecount()

1wreset
1wwrite &H55                                                ' Budu vysilat adresu
1wwrite Adresy(1) , 8                                       ' Vysilam adresu
1wwrite &HBE                                                ' Prikaz cidla o zaslani adresy
Cidlo_1(1) = 1wread(9)
1wreset
1wwrite &H55
1wwrite Adresy(9) , 8
1wwrite &HBE
Cidlo_2(1) = 1wread(9)
1wreset
1wwrite &HCC                                                ' Prikaz skip ROM, poslouchejte vsichni
1wwrite &H44                                                ' Prikaz konverze teploty

T = Makeint(cidlo_1(1) , Cidlo_1(2))
T = T * 10
T = T / 16

Temp1_str = Str(t)

T = T / 10                                                  'srovnava se s promennou typu Byte, proto /10
If T > Prehrati Or T = Prehrati Then                        'signalizace prehrati
   Portc.3 = 0                                              'Vystup zapnut LED RUDA
   Ok = 0                                                   'vypnuti zdroje pri prehrati
  Else
   Portc.3 = 1                                              'Vystup vypnut LED RUDA
End If

T = Makeint(cidlo_2(1) , Cidlo_2(2))
T = T * 10
T = T / 16
'Print "T2 " ; T
Temp2_str = Str(t)

Temp1_str = Format(temp1_str , "0.0")
Temp2_str = Format(temp2_str , "0.0")

If W = 0 Then
  Temp1_str = "  - "
  Temp2_str = "  - "
End If

If W = 1 Then
  Temp2_str = "  - "
End If

'Print Temp1_str
'Print Temp2_str

Return




Mereni_napeti:
  Do
    Channel(cykl + 1) = Getadc(cykl)
    Incr Cykl
  Loop Until Cykl = 8
  Cykl = 0
Return





Nacteni_korekci:                                            'soucet je korekce v 0,1%, 127 je stred bytu - nula procent

Readeeprom Korekce_pomocna , 1                              'Korekce vetve -5V
 Korekce_celkova(1) = Korekce_pomocna + 873
'Readeeprom Korekce_pomocna , 2                              'Korekce vetve PG
' Korekce_celkova(2) = Korekce_pomocna + 873
Readeeprom Korekce_pomocna , 3                              'Korekce vetve 12V2
 Korekce_celkova(3) = Korekce_pomocna + 873
Readeeprom Korekce_pomocna , 4                              'Korekce vetve 12V1
 Korekce_celkova(4) = Korekce_pomocna + 873
Readeeprom Korekce_pomocna , 5                              'Korekce vetve 5V ST-BY
 Korekce_celkova(5) = Korekce_pomocna + 873
Readeeprom Korekce_pomocna , 6                              'Korekce vetve 5V
 Korekce_celkova(6) = Korekce_pomocna + 873
Readeeprom Korekce_pomocna , 7                              'Korekce vetve 3,3V
 Korekce_celkova(7) = Korekce_pomocna + 873
Readeeprom Korekce_pomocna , 8                              'Korekce vetve -12V
 Korekce_celkova(8) = Korekce_pomocna + 873

Return





Inicializace:

Readeeprom Prehrati , 10                                    'Nastaveni teploty prehrati
'Prehrati = 80

Readeeprom Tolerance_pozadovana_min(1) , 11                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_min(3) , 13                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_min(4) , 14                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_min(5) , 15                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_min(6) , 16                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_min(7) , 17                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_min(8) , 18                 'Nastaveni pozadovane tolerance

Readeeprom Tolerance_pozadovana_max(1) , 21                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_max(3) , 23                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_max(4) , 24                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_max(5) , 25                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_max(6) , 26                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_max(7) , 27                 'Nastaveni pozadovane tolerance
Readeeprom Tolerance_pozadovana_max(8) , 28                 'Nastaveni pozadovane tolerance

Portc.1 = 1                                                 'inicializace vystupu start zdroje
Portc.2 = 0                                                 'inicializace vystupu piskle
Portc.3 = 1                                                 'inicializace vystupu LED RUDA
Portc.4 = 1                                                 'inicializace vystupu LED ZELENA

Waitms 50
Portc.2 = 0                                                 'pipnuti pri startu
Waitms 50
Portc.2 = 1
Waitms 50
Portc.2 = 0
Waitms 50
Portc.2 = 1
Waitms 50
Portc.2 = 0
Waitms 50
Portc.2 = 1
Waitms 50
Portc.2 = 0

Cursor Off
Cls

Return




Vymazani_minim:
Minimum(1) = 9999                                           'Vymazani_minima -5V
Minimum(3) = 9999                                           'Vymazani_minima 12V2
Minimum(4) = 9999                                           'Vymazani_minima 12V1
Minimum(5) = 9999                                           'Vymazani_minima 5V ST-BY
Minimum(6) = 9999                                           'Vymazani_minima 5V
Minimum(7) = 9999                                           'Vymazani_minima 3,3V
Minimum(8) = 9999                                           'Vymazani_minima -12V

Maximum(1) = 0                                              'Vymazani_maxima -5V
Maximum(3) = 0                                              'Vymazani_maxima 12V2
Maximum(4) = 0                                              'Vymazani_maxima 12V1
Maximum(5) = 0                                              'Vymazani_maxima 5V ST-BY
Maximum(6) = 0                                              'Vymazani_maxima 5V
Maximum(7) = 0                                              'Vymazani_maxima 3,3V
Maximum(8) = 0                                              'Vymazani_maxima -12V
Return




Pip:
   Portc.2 = 1
   Waitms 30
   Portc.2 = 0
Return





Tim0_isr:
Incr Citani_casu
If Citani_casu > 39060 Then
   Citani_time_overflow = 1
End If
Return





Print_port:

Export = Time$ + " " + Printport(4) + " " + Printport(9) + " " + Printport(8) + " " + Printport(7) + " " + Printport(5) + " " + Printport(6) + " -" + Printport(3) + " -" + Printport(10) + " " + Printport(2) + " " + Printport(1)

Export_crc = Checksum(export)                               'vypocte kontrolni soucet

If Export_crc_old <> Export_crc Then                        'pokud je kontrolni soucet ruzny od predchoziho mereni, zobrazi namerene hodnoty
   Print Export
End If

Export_crc_old = Export_crc                                 'zapamatuje predchozi mereni

Return