unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, ExtCtrls, inifiles, unitx;

type


  TReadThread = class(TThread)
  public
   fs: string;
   constructor Create;
   procedure Execute; override;
   procedure ShowStr;
  end;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    sb1: TStatusBar;
    device1: TMenuItem;
    m: TMemo;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Panel1: TPanel;
    Info1: TMenuItem;
    N2: TMenuItem;
    data1: TMenuItem;
    Label5: TLabel;
    Portsstatus1: TMenuItem;
    Timer1: TTimer;
    GetStatus1: TMenuItem;
    GetTime1: TMenuItem;
    SetDateTime1: TMenuItem;
    SetTimer1: TMenuItem;
    tmr: TEdit;
    Label1: TLabel;
    Program2: TMenuItem;
    SetManualDateTime1: TMenuItem;
    Label3: TLabel;
    mandatetime: TEdit;
    Getcurrentrule1: TMenuItem;
    Gettemperature1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Portsstatus1Click(Sender: TObject);
    procedure GetTime1Click(Sender: TObject);
    procedure SetDateTime1Click(Sender: TObject);
    procedure SetTimer1Click(Sender: TObject);
    procedure GetStatus1Click(Sender: TObject);
    procedure Program2Click(Sender: TObject);
    procedure SetManualDateTime1Click(Sender: TObject);
    procedure Getcurrentrule1Click(Sender: TObject);
    procedure Gettemperature1Click(Sender: TObject);
    procedure Read8byteeprom1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
   procedure AddStr(s:string);
   function  OpenPort: boolean;
   procedure SendCmd(cmd: string; chars: byte);
  end;

const
  rcvsize=10000;
  weekday: array [0..7] of string = ('Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday','Unknown');

  cmdlength = 10;
//  getecho = #0;
  infocmd = #1;
  get_port_status = #2;
  GetTemperatures = #3;
  WriteEpromByte = #4;
  ReadEpromByte = #5;
  WriteEpromByte8 = #6;
  ReadEpromByte8 = #7;
//  SetTemperature = #8;
//  DebugPrint = #9;
//  HeatOnOff = #10;
  SetDateTime = #11;
  GetDateTime = #12;
  SetTimer = #13;
  SendRule = #14;
  UpdateTempRule = #15;

  onoff: array [boolean] of string = ('OFF','ON');
  onbatt: array [boolean] of string = ('OK','ON BATT');

type
  rcvbuf = array [0..rcvsize] of char;
  tshowdata=(shhex,shbinary,shascii);

var
  Form1: TForm1;
  nrcv: cardinal;
  rcv: rcvbuf;

implementation

uses Unit2;


{$R *.DFM}


const
  initsection='init';

  comhandle: thandle= 0;
  readthread: treadthread = nil;
  portopen: boolean = false;
  showsend: boolean = false;
  showdata: tshowdata = shhex;
  showcrlf: boolean = false;
  showlog: boolean = true;
  autoopen: boolean = true;
  loglines: integer = 100;
  showtimestamp: boolean = true;
  writelogtofile: boolean = true;

var
  inifilepth: string;
  vref: real = 4.96;


constructor TReadThread.Create;
begin
 inherited Create(true);
 freeonterminate := true;
 priority := tpNormal;
 resume;
end;

procedure TReadthread.ShowStr;
begin
 if (Form1 <> nil) and (fs <> '') then Form1.addstr('R: '+ fs);
end;

procedure TReadthread.Execute;
var i: integer;
    r: array [0..rcvsize] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 repeat
try
  if ClearCommError(comhandle,cst,@st) then begin
    sleepex(10,true);
    if st.cbInQue > 0 then begin
      if readfile(comhandle, r, sizeof(r)-1, nr, nil) then begin

       if nrcv + nr > rcvsize then begin
        fs := 'Buffer full'; Synchronize(ShowStr);
        nrcv := 0;
        if nr > rcvsize then continue; // discard chars
       end;

        move(r[0],rcv[nrcv],nr); nrcv := nrcv + nr;  fs := '';
        if nr <> 0 then begin
         for i := 0 to nr-1 do begin
          case showdata of
           shhex: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + inttohex(byte(r[i]),2);
           end;
           shbinary: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + binb(byte(r[i]));
           end;
           shascii: begin
            if r[i] = #13 then fs := fs + '<CR>' else
            if r[i] = #10 then fs := fs + '<LF>' else
            if r[i] in [#32..#126] then fs := fs + r[i] else
              fs := fs + '0x'+inttohex(byte(r[i]),2);
           end;
          end;
          if showdata <> shascii then fs := fs + ' ';
         end;
          Synchronize(ShowStr);
        end;
      end;
    end;
  end;
except
 on e: exception do ebox('Thread '+e.message);
end;
 until application.Terminated or terminated;
end;




function waitrcv(chars: byte): boolean;
var t: tdatetime;
    timeout: boolean;
begin
 t := now + 2/(24*3600);
 repeat
  sleepex(100,true);
  timeout := t < now;
  application.ProcessMessages;
 until (nrcv >= chars) or timeout;
 if timeout then result := false else result := true;
end;

function DoOpenPort(var ph: thandle): boolean;
var dcb: tdcb;
    t:COMMTIMEOUTS;
    f: TIniFile;
    c: string;
    brate: integer;
begin
 result := false;
 f := tinifile.create(inifilepth);
try
 c := uppercase(f.ReadString(initsection,'port','\\.\COM1'));
 brate := f.ReadInteger(initsection,'baud',19200);

finally
 f.free;
end;
 ph := CreateFile(pchar(c),
    GENERIC_READ or GENERIC_WRITE, 0,nil, OPEN_EXISTING, 0, 0);

 if ph = INVALID_HANDLE_VALUE then begin
  ebox('CreateFile INVALID_HANDLE_VALUE'#13+syserrormessage(GetLastError));
  exit;
 end;

 dcb.DCBlength := sizeof(dcb);
 if not GetCommState(ph, dcb) then
  begin
   ebox('ComHandle GetCommState '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 dcb.BaudRate := brate;
 dcb.Parity := 0;
 dcb.ByteSize := 8;
 dcb.StopBits := ONESTOPBIT;

 if not SetCommState(ph, dcb) then
  begin
   ebox('ComHandle SetCommState '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 EscapeCommFunction(ph, SETDTR);
 EscapeCommFunction(ph, SETRTS);

 if not  getcommtimeouts(ph,t) then
  begin
   ebox('ComHandle GetCommTimeOuts '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 t.ReadIntervalTimeout := 100;
 t.ReadTotalTimeoutMultiplier := 1;

 if not setcommtimeouts(ph, t) then
  begin
   ebox('ComHandle SetCommTimeOuts '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;
{
 if not PurgeComm(ph, PURGE_RXCLEAR or PURGE_TXCLEAR) then begin
  ebox('ComHandle PurgeComm '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
  exit;
 end;
}
 result := true;
end;

procedure ClearCom(h: thandle);
var r: array [0..1000] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 if ClearCommError(comhandle,cst,@st) and (st.cbInQue > 0) then begin
  readfile(h, r, sizeof(r)-1, nr, nil);
 end;
end;

function TForm1.OpenPort: boolean;
begin

 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;

 if comhandle <> 0 then if closehandle(comhandle) then comhandle := 0;
 result := false;

 if not DoOpenPort(comhandle) then exit;

 if not SetCommMask(comhandle, EV_RXCHAR) then begin
  ebox('ComHandle SetCommMask '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
 end;

 sleep(100);
 ClearCom(comhandle);
 readthread := Treadthread.Create;

 result := true;
 portopen := true;
 addstr('COM port opened');
end;


function SendString(s: string): boolean;
var wb: cardinal;
    l: integer;
begin
 result := false;
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 l := length(s);
 if not writefile(comhandle, s[1], l, wb, nil) then begin
  EBox(syserrormessage(getlasterror));
 end else result := true;
end;

procedure TForm1.AddStr(s:string);
var t: tdatetime;
begin
 if not showlog then exit;
 t := now;
 m.lines.BeginUpdate;
try
 if writelogtofile then xwritetostringfile(formatdatetime('dd.mm.yyyy hh:nn:ss.zzz ',t)+s+#13#10,_exedir+_exename+'.log');
 if showtimestamp then s := formatdatetime('dd.mm.yyyy hh:nn:ss.zzz ',t) + s;
 while m.lines.count > loglines do begin
  m.Lines.Delete(m.lines.count-1);
 end;
 m.lines.insert(0,trimright(s));
finally
 m.lines.EndUpdate;
end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Ibox('Heater service'#13#13'(c) Zelenka 2013');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

const issending: boolean = false;
procedure TForm1.SendCmd(cmd: string; chars: byte);
var s,p: string;
    i: integer;
begin
 if issending then begin
  beep;
  showlog := true;
  addstr('Cmd in progress...');
  exit;
 end;
 issending := true;
try
 sb1.Panels[1].text := '';
 if not portopen then OpenPort;
 for i := length(cmd)+1 to cmdlength do cmd := cmd + #0;
 sb1.Panels[1].text := 'Sending data...';
 p := '';
 for i := 1 to length(cmd) do p := p + '0x'+inttohex(byte(cmd[i]),2)+' ';
 if showsend then addstr('S: '+p)
  else addstr('S: '+inttostr(length(cmd))+'B');
 if sendstring(cmd) then begin
  if waitrcv(chars) then begin
  s := copy(rcv,1,nrcv-2);
  end else begin
   addstr('Receive error!');
   beep;
  end;
 end;
 sb1.Panels[1].Text := p;
finally
 issending := false;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var f: tinifile;
begin
 mandatetime.text := formatdatetime('dd.mm.yyyy hh:nn:ss',now);
 decimalseparator := '.';
 m.Clear;
 inifilepth := _exedir+_exename+'.ini';
 f := tinifile.create(inifilepth);
try
 autoopen := f.ReadBool(initsection,'AutoOpen',autoopen);
 loglines := f.ReadInteger(initsection,'LogLines',loglines);
 vref := f.ReadFloat(initsection,'Vref',vref);
finally
 f.free;
end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 EscapeCommFunction(comhandle, CLRRTS);
 EscapeCommFunction(comhandle, CLRDTR);
 if comhandle <> 0 then closehandle(comhandle);
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 OpenPort;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;
 if comhandle <> 0 then
 if closehandle(comhandle) then begin
  portopen := false;
  comhandle := 0;
 end;
 addstr('COM port closed');
end;

const first:boolean = true;
procedure TForm1.FormActivate(Sender: TObject);
begin
 if first then begin
  first := false;
  if autoopen then OpenPort;
 end;
end;

procedure TForm1.Info1Click(Sender: TObject);
var b: tshowdata;
begin
 b := showdata;
 showdata := shascii;
 SendCmd(infocmd,2);
 showdata := b;
end;

procedure TForm1.Portsstatus1Click(Sender: TObject);
var b: array [0..3] of byte;
begin
 sendcmd(get_port_status,11);
 if nrcv > 4 then begin
  move(rcv[0],b,sizeof(b));
  addstr(format('Port C: %s, Port A: %s',[binb(b[0]),binb(b[1])]));
 end;
end;

procedure TForm1.GetStatus1Click(Sender: TObject);
var b: array [0..20] of byte;
    bb: word;
    t1,t2,t3: byte;
    s1,s2,s3: string;
begin
 sendcmd(get_port_status,11);
 if nrcv >= 11 then begin
  move(rcv[0],b,sizeof(b));
  bb := b[4]*256+b[5];
  t1 := b[6]; t2 := b[7]; t3 := b[8];
  if t1 = 255 then s1 := 'NI' else begin
   s1 :=format('%d.%d',[t1 shr 1,(t1 and 1)*5]);
   if t1 and 128 = 128 then begin
    t1 := t1 and not 128;
    s1 :=format('-%d.%d',[t1 shr 1,(t1 and 1)*5]);
   end;
  end;
  if t2 = 255 then s2 := 'NI' else begin
   s2 :=format('%d.%d',[t2 shr 1,(t2 and 1)*5]);
   if t2 and 128 = 128 then begin
    t2 := t2 and not 128;
    s2 :=format('-%d.%d',[t2 shr 1,(t2 and 1)*5]);
   end;
  end;
  if t3 = 255 then s3 := 'NI' else begin
   s3 :=format('%d.%d',[t3 shr 1,(t3 and 1)*5]);
   if t3 and 128 = 128 then begin
    t3 := t3 and not 128;
    s3 :=format('-%d.%d',[t3 shr 1,(t3 and 1)*5]);
   end;
  end;
  
  addstr(format('Timer: %.2x%.2x (%d)',[b[4],b[5],bb]));
  addstr(format('Port C: %s, Port A: %s',[binb(b[0]),binb(b[1])]));
  addstr(format('Flags: %s, Flags1: %s',[binb(b[2]),binb(b[3])]));
  addstr(format('Temp1: %s, Temp2: %s, Temp3: %s',[s1,s2,s3]));
  addstr(format('Pump1: %s, Pump2: %s, Pump3: %s',
         [onoff[b[0] and 4 = 4],onoff[b[0] and 2 = 2],onoff[b[0] and 1 = 1]]));
  addstr(format('Power: %s, Heat: %s',
         [onbatt[b[2] and 1 = 1], onoff[b[0] and 16 = 16]]));

  tmr.Text := inttostr(bb);
 end;
end;

procedure TForm1.GetTime1Click(Sender: TObject);
var b: record
     c,y,m,d,dw,ho,mi,se: byte;
    end;
    t,d,dd: tdatetime;
    s: byte;
const sign: array [0..1] of string = ('','-');
begin
 t := time;
 sendcmd(GetDateTime,2);
 if nrcv = 10 then begin
  move(rcv[0],b,sizeof(b));
  d := (1/(24*3600))* (b.ho*3600+b.mi*60+b.se/2);
  dd := d-t;
  s := byte(boolean(dd<0));
  if b.dw > 6 then b.dw := 7; // unknown
  addstr(format('%s %.2d:%.2d:%4.1f Diff: %s%s',[weekday[b.dw],b.ho,b.mi,b.se/2,
   sign[s],formatdatetime('hh:nn:ss.zzz',dd)]));
 end;
end;

procedure TForm1.SetDateTime1Click(Sender: TObject);
var t: TDateTime;
    y,m,d,ho,mi,se,mse: word;
    cent,year: byte;
    dw: integer;
begin
 if QBox('Are you sure?') = idyes then begin
  addstr('Setting DateTime ...' );
  t := Now + 2/(24*3600);
  DecodeDate(t,y,m,d);
  DecodeTime(t,ho,mi,se,mse);
  dw := DayOfWeek(t)-2; // 1 = sunday
  if dw < 0 then dw := 6;
  t := EncodeDate(y, m, d) + EncodeTime(ho,mi,se,0);
  while t > Now do begin
   sleep(1);
  end;
  cent := y div 100;
  year := y - cent * 100;
// cent, year, month, day, dweek (0-6), hour, min, sec
  sendcmd(SetDateTime+char(cent)+char(year)+char(byte(m))+char(byte(d))+
          char(byte(dw))+char(byte(ho))+char(byte(mi))+char(byte(se*2)),2);
  sleep(500);
  sendcmd(UpdateTempRule,2);
  GetTime1Click(Sender);
 end;
end;

procedure TForm1.SetManualDateTime1Click(Sender: TObject);
var t: TDateTime;
    y,m,d,ho,mi,se,mse: word;
    cent,year: byte;
    dw: integer;
begin
 if QBox('Are you sure? "'+trim(mandatetime.text)+'"') = idyes then begin
  t := StrtoDateTime(trim(mandatetime.text));
  DecodeDate(t,y,m,d);
  DecodeTime(t,ho,mi,se,mse);
  dw := DayOfWeek(t)-2; // 1 = sunday
  if dw < 0 then dw := 6;
  cent := y div 100;
  year := y - cent * 100;
// cent, year, month, day, dweek (0-6), hour, min, sec
  sendcmd(SetDateTime+char(cent)+char(year)+char(byte(m))+char(byte(d))+
          char(byte(dw))+char(byte(ho))+char(byte(mi))+char(byte(se*2)),2);
          sleep(100);
  sendcmd(UpdateTempRule,2)
 end;
end;

procedure TForm1.SetTimer1Click(Sender: TObject);
var w: word;
begin
 w := strtoint(trim(tmr.text));
 if QBox('Are you sure? "'+inttostr(w)+'"') = idyes then begin
  addstr('Setting timer: '+inttostr(w));
  sendcmd(SetTimer+char(hi(w))+char(lo(w)),2);
 end;
end;

procedure TForm1.Program2Click(Sender: TObject);
begin
 form2.show;
end;

procedure TForm1.Getcurrentrule1Click(Sender: TObject);
var a: array[0..100] of byte;
begin
 sendcmd(SendRule,9);
 if nrcv >= 7 then begin
  move(rcv[0],a,sizeof(a));
  addstr(format('HeatOn: %s, HeatOff: %s, Time: %d:%d, Temp: %d.%d',
  [onoff[boolean(a[3] and 128=128)],onoff[boolean(a[3] and 64 = 64)],a[3] and 63,a[4],a[1] shr 1,(a[1] and 1)*5]));
 end;
end;

procedure TForm1.Gettemperature1Click(Sender: TObject);
begin
 sendcmd(GetTemperatures,2);
 GetStatus1Click(Sender);
end;

procedure TForm1.Read8byteeprom1Click(Sender: TObject);
begin
 sendcmd(ReadEpromByte8,10);
end;

end.


