unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, unitx;

type
  TForm2 = class(TForm)
    pc1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    TabSheet11: TTabSheet;
    TabSheet12: TTabSheet;
    TabSheet13: TTabSheet;
    TabSheet14: TTabSheet;
    TabSheet15: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    temp: TComboBox;
    stime: TEdit;
    prgenable: TCheckBox;
    Label9: TLabel;
    p2: TCheckBox;
    p1: TCheckBox;
    p3: TCheckBox;
    p4: TCheckBox;
    Label3: TLabel;
    p5: TCheckBox;
    p6: TCheckBox;
    p7: TCheckBox;
    p8: TCheckBox;
    s2: TCheckBox;
    s1: TCheckBox;
    s3: TCheckBox;
    s4: TCheckBox;
    s5: TCheckBox;
    s6: TCheckBox;
    s7: TCheckBox;
    s8: TCheckBox;
    d2: TCheckBox;
    d1: TCheckBox;
    d3: TCheckBox;
    d4: TCheckBox;
    d5: TCheckBox;
    d6: TCheckBox;
    d7: TCheckBox;
    hon: TCheckBox;
    hoff: TCheckBox;
    od: TOpenDialog;
    sd: TSaveDialog;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure pc1Change(Sender: TObject);
    procedure pc1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure hoffClick(Sender: TObject);
    procedure honClick(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


const
  maxdata = 15;

type
  TProgramData = record
   Idx, Temp, Wd, Ho, Mi, Sensor, Pump: byte;
   Reserved: array [0..8] of byte;
   // Program ENABLE is bit 7 at Wd
   // Heat ON is bit 7 at Ho
   // Heat OFF is bit 6 at Ho
  end;
  TProgramDataArray = record
   PD: array [1..maxdata] of TProgramData;
  end;


var
  Form2: TForm2;
  PD: TProgramDataArray;
  DataChanging: boolean = false;


implementation

uses Unit1;

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
begin
 temp.ItemIndex := 32;
 fillchar(pd,sizeof(pd),0);
 pc1.ActivePageIndex := 0;
 sd.InitialDir := _exedir;
 od.InitialDir := _exedir;
end;

procedure TForm2.BitBtn4Click(Sender: TObject);
var d: TProgramDataArray;
    f: file of byte;
begin // load from file
 DataChanging := true;
try
 fillchar(d,sizeof(d),0);
 if od.execute then begin
  assignfile(f,od.FileName);
  reset(f);
  blockread(f,d,sizeof(d));
  closefile(f);
  move(d,pd,sizeof(pd));
 end;
finally
 DataChanging := false;
 pc1Change(self);
end;
end;

procedure SavePrgFile(s: string; d: TProgramDataArray);
var f: file of byte;
    a: array [1..1024] of byte;
    i,j,t1,t2: integer;
    ss: string;
    xon,xof: boolean;
begin
 assignfile(f,s);
 rewrite(f);
 blockwrite(f,d,sizeof(d));
 closefile(f);
// save to text file...
 move(d,a,sizeof(d));
 ss := _exedir+'$$$.$$$';
 Xwritetonewstringfile('No  Idx Temp WeekDay  ON OFF Ho Mi Sensor   Pump'#13#10,ss);
 for i := 1 to 15 do begin
  j := (i-1)*16;
// Idx, Temp, Wd, Ho, Mi, Sensor, Pump: byte;
// Program ENABLE is bit 7 at Wd
// Heat ON is bit 7 at Ho
// Heat OFF is bit 6 at Ho
  xon := a[j+4] and 128 = 128; xof := a[j+4] and 64 = 64;
  t1 := (a[j+2] shr 1); t2 := (a[j+2] and 1)*5;
  Xwritetostringfile(  format('%3d %3d %2d.%1d %s  %d  %d  %.2d:%.2d %s %s'#13#10,
  [i,a[j+1],t1,t2,binb(a[j+3]),byte(xon),byte(xof),a[j+4] and 63,a[j+5],binb(a[j+6]),binb(a[j+7])]),ss);
 end;
end;

procedure TForm2.BitBtn3Click(Sender: TObject);
var b: boolean;
begin // save to file
 pc1Changing(sender,b);
 if sd.execute then begin
  SavePrgFile(sd.filename,pd);
 end;
end;

procedure TForm2.BitBtn2Click(Sender: TObject);
var i: integer;
    d: TProgramDataArray;
begin // load from device
 if qbox('Load data from device. Are you sure?') <> idyes then exit;
 DataChanging := true;
try
 fillchar(d,sizeof(d),0);
 for i := 1 to maxdata do begin
   form1.SendCmd(ReadEpromByte8+char(i*8),10);
   if nrcv = 10 then begin
    move(rcv[0],d.pd[i],sizeof(TProgramData));
   end else begin
    Ebox('');
    exit;
   end;
  move(d,pd,sizeof(pd));
  SavePrgFile(_exedir + '$eprom$.prg',pd);
 end;
finally
 DataChanging := false;
 pc1Change(self);
end;
end;

procedure SortData(var d: TProgramDataArray);
var i,j,k: integer;
    p: TProgramData;
    dd:TProgramDataArray;
    t1,t2: integer;
begin
 move(d,dd,sizeof(dd));
 for i := 1 to maxdata do begin
  dd.PD[i].Idx := i;
 end;
 for i := 1 to maxdata-1 do begin
   for j := 1 to maxdata-1 do begin
     t1 := (dd.PD[j].Ho and 63)*60+dd.PD[j].Mi;
     t2 := (dd.PD[j+1].Ho and 63)*60+dd.PD[j+1].Mi;
     if t2 < t1 then begin
      move(dd.PD[j+1],p,sizeof(p));
      move(dd.PD[j],dd.PD[j+1],sizeof(p));
      move(p,dd.PD[j],sizeof(p));
     end;
   end;
 end;
 for i := 1 to maxdata do begin
  k := dd.PD[i].Idx;
  d.PD[k].Idx := i;
 end;
end;

procedure TForm2.BitBtn1Click(Sender: TObject);
var i: integer;
    s: string;
    b: boolean;
begin // store to device
 pc1Changing(sender,b);
 if qbox('Store data to device. Are you sure?') <> idyes then exit;
 sortdata(pd);
 SavePrgFile(_exedir + '$eprom$.sav',pd);
  for i := 1 to maxdata do begin
   s := char(pd.PD[i].Idx)+
        char(pd.PD[i].Temp)+
        char(pd.PD[i].Wd)+
        char(pd.PD[i].Ho)+
        char(pd.PD[i].Mi)+
        char(pd.PD[i].Sensor)+
        char(pd.PD[i].Pump);
   form1.SendCmd(WriteEpromByte8+char(i*8)+s,2);
   if nrcv = 2 then begin
   end else begin
    Ebox('Error on write?!');
    exit;
   end;
  end;
 form1.sendcmd(UpdateTempRule,2)
end;

procedure TForm2.BitBtn5Click(Sender: TObject);
begin
 close;
end;

procedure TForm2.BitBtn6Click(Sender: TObject);
begin
 if qbox('Clear ALL. Are you sure?') <> idyes then exit;
 fillchar(pd,sizeof(pd),0);
 pc1Change(self);
end;

procedure TForm2.BitBtn7Click(Sender: TObject);
var i: integer;
begin
 i := pc1.ActivePageIndex + 1;
 if qbox(format('Clear Prg %.2d. Are you sure?',[i])) <> idyes then exit;
 fillchar(pd.PD[i],sizeof(TProgramData),0);
 pc1Change(self);
end;

procedure TForm2.pc1Change(Sender: TObject);
var i: integer;
    t: byte;
begin  // after TS change
 if DataChanging then exit;
 i := pc1.ActivePageIndex + 1;
 t := ((pd.PD[i].Temp shr 1) - 5)*2 + byte(pd.PD[i].Temp and 1 = 1);
 if t > 50 then t := 0;
 temp.itemindex := t;  // 5 - 30
 d1.checked := pd.PD[i].Wd and 1 = 1;
 d2.checked := pd.PD[i].Wd and 2 = 2;
 d3.checked := pd.PD[i].Wd and 4 = 4;
 d4.checked := pd.PD[i].Wd and 8 = 8;
 d5.checked := pd.PD[i].Wd and 16 = 16;
 d6.checked := pd.PD[i].Wd and 32 = 32;
 d7.checked := pd.PD[i].Wd and 64 = 64;
 prgenable.Checked := (pd.PD[i].Wd and 128) = 128;
 stime.text := format('%.2d:%.2d',[pd.PD[i].Ho and 63,pd.PD[i].Mi]);
 hon.Checked := pd.PD[i].Ho and 128 = 128;
 hoff.Checked := pd.PD[i].Ho and 64 = 64;
 s1.checked := pd.PD[i].Sensor and 1 = 1;
 s2.checked := pd.PD[i].Sensor and 2 = 2;
 s3.checked := pd.PD[i].Sensor and 4 = 4;
 s4.checked := pd.PD[i].Sensor and 8 = 8;
 s5.checked := pd.PD[i].Sensor and 16 = 16;
 s6.checked := pd.PD[i].Sensor and 32 = 32;
 s7.checked := pd.PD[i].Sensor and 64 = 64;
 s8.checked := pd.PD[i].Sensor and 128 = 128;
 p1.checked := pd.PD[i].Pump and 1 = 1;
 p2.checked := pd.PD[i].Pump and 2 = 2;
 p3.checked := pd.PD[i].Pump and 4 = 4;
 p4.checked := pd.PD[i].Pump and 8 = 8;
 p5.checked := pd.PD[i].Pump and 16 = 16;
 p6.checked := pd.PD[i].Pump and 32 = 32;
 p7.checked := pd.PD[i].Pump and 64 = 64;
 p8.checked := pd.PD[i].Pump and 128 = 128;
end;

procedure TForm2.pc1Changing(Sender: TObject; var AllowChange: Boolean);
var i: integer;
    t: byte;
    tt: tdatetime;
    h,m,s,ss: word;
begin  // before TS change
 if DataChanging then exit;
 i := pc1.ActivePageIndex + 1;
 t := (((temp.itemindex +10) div 2) shl 1) + byte((temp.itemindex mod 2) <> 0);
 pd.PD[i].Temp := t;

 pd.PD[i].Wd := byte(d1.checked) +
                byte(d2.checked)*2+
                byte(d3.checked)*4+
                byte(d4.checked)*8+
                byte(d5.checked)*16+
                byte(d6.checked)*32+
                byte(d7.checked)*64+
                byte(prgenable.checked)*128;
try
 tt := strtotime(trim(stime.text));
 decodetime(tt,h,m,s,ss);
except
 on e: exception do begin
  h := 0; m := 0;
  ebox(e.message+#13#13'Setting time to 0:0!');
 end;
end;
 pd.PD[i].Ho := h;
 pd.PD[i].Mi := m;
 pd.PD[i].Ho := pd.PD[i].Ho + byte(hon.checked)*128 + byte(hoff.checked)*64;
 pd.PD[i].Sensor := byte(s1.checked) +
                    byte(s2.checked)*2+
                    byte(s3.checked)*4+
                    byte(s4.checked)*8+
                    byte(s5.checked)*16+
                    byte(s6.checked)*32+
                    byte(s7.checked)*64+
                    byte(s8.checked)*128;
 pd.PD[i].Pump := byte(p1.checked) +
                  byte(p2.checked)*2+
                  byte(p3.checked)*4+
                  byte(p4.checked)*8+
                  byte(p5.checked)*16+
                  byte(p6.checked)*32+
                  byte(p7.checked)*64+
                  byte(p8.checked)*128;
end;

var check_process: boolean = false;
procedure TForm2.hoffClick(Sender: TObject);
begin
 if check_process then exit;
 check_process := true;
 hon.checked := false;
 application.processmessages;
 check_process := false;
end;

procedure TForm2.honClick(Sender: TObject);
begin
 if check_process then exit;
 check_process := true;
 hoff.checked := false;
 application.processmessages;
 check_process := false;
end;



end.
